/*********************************************************************
 *                    Flowcode USB Component Code
 *
 * File: pic_usb_buffer_mgt.h
 *
 * (c) 2009 Matrix Multimedia Ltd.
 * http://www.matrixmultimedia.com
 *
 * Software License Agreement
 *
 * The software supplied herewith by Matrix Multimedia Ltd (the
 * Company) for its Flowcode graphical programming language is
 * intended and supplied to you, the Companys customer, for use
 * solely and exclusively on the Company's products. The software
 * is owned by the Company, and is protected under applicable
 * copyright laws. All rights are reserved. Any use in violation
 * of the foregoing restrictions may subject the user to criminal
 * sanctions under applicable laws, as well as to civil liability
 * for the breach of the terms and conditions of this licence.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Changelog:
 *
 *  date  | by | description
 * -------+----+-----------------------------------------------------
 * 031008 | BR | Created
 * 190711 | BR | Confirmed current version
 * 230614 | LM | Support for 18F45K50
 ********************************************************************/

#ifndef __pic_usb_buffer_mgt_h
#define __pic_ubs_buffer_mgt_h

#include "pic_usb.h"

#if (USB_DESCRIPTOR_BASE_ADDRESS == 0x2000)
// JK: Work around BoostC issue with FSR access only for arrays
extern	uns8	bd0aout_stat[1];
extern	uns8	bd0aout_count[1];
extern	uns16	bd0aout_addr[1];
extern	uns8	bd0ain_stat[1];
extern	uns8	bd0ain_count[1];
extern	uns16	bd0ain_addr[1];

extern	uns8	bd1aout_stat[1];
extern	uns8	bd1aout_count[1];
extern	uns16	bd1aout_addr[1];
extern	uns8	bd1ain_stat[1];
extern	uns8	bd1ain_count[1];
extern	uns16	bd1ain_addr[1];

extern	uns8	bd2aout_stat[1];
extern	uns8	bd2aout_count[1];
extern	uns16	bd2aout_addr[1];
extern	uns8	bd2ain_stat[1];
extern	uns8	bd2ain_count[1];
extern	uns16	bd2ain_addr[1];

extern	uns8	bd3aout_stat[1];
extern	uns8	bd3aout_count[1];
extern	uns16	bd3aout_addr[1];
extern	uns8	bd3ain_stat[1];
extern	uns8	bd3ain_count[1];
extern	uns16	bd3ain_addr[1];

#define	bd0out_stat	bd0aout_stat[0]
#define	bd0out_count	bd0aout_count[0]
#define	bd0out_addr	bd0aout_addr[0]
#define	bd0in_stat	bd0ain_stat[0]
#define	bd0in_count	bd0ain_count[0]
#define	bd0in_addr	bd0ain_addr[0]
#define	bd1out_stat	bd1aout_stat[0]
#define	bd1out_count	bd1aout_count[0]
#define	bd1out_addr	bd1aout_addr[0]
#define	bd1in_stat	bd1ain_stat[0]
#define	bd1in_count	bd1ain_count[0]
#define	bd1in_addr	bd1ain_addr[0]
#define	bd2out_stat	bd2aout_stat[0]
#define	bd2out_count	bd2aout_count[0]
#define	bd2out_addr	bd2aout_addr[0]
#define	bd2in_stat	bd2ain_stat[0]
#define	bd2in_count	bd2ain_count[0]
#define	bd2in_addr	bd2ain_addr[0]
#define	bd3out_stat	bd3aout_stat[0]
#define	bd3out_count	bd3aout_count[0]
#define	bd3out_addr	bd3aout_addr[0]
#define	bd3in_stat	bd3ain_stat[0]
#define	bd3in_count	bd3ain_count[0]
#define	bd3in_addr	bd3ain_addr[0]
#else
extern buffer_descriptor bd0out;
extern buffer_descriptor bd0in;
extern buffer_descriptor bd1out;
extern buffer_descriptor bd1in;
extern buffer_descriptor bd2out;
extern buffer_descriptor bd2in;
extern buffer_descriptor bd3out;
extern buffer_descriptor bd3in;

#define	bd0out_stat	bd0out.stat
#define	bd0out_count	bd0out.count
#define	bd0out_addr	bd0out.addr
#define	bd0in_stat	bd0in.stat
#define	bd0in_count	bd0in.count
#define	bd0in_addr	bd0in.addr
#define	bd1out_stat	bd1out.stat
#define	bd1out_count	bd1out.count
#define	bd1out_addr	bd1out.addr
#define	bd1in_stat	bd1in.stat
#define	bd1in_count	bd1in.count
#define	bd1in_addr	bd1in.addr
#define	bd2out_stat	bd2out.stat
#define	bd2out_count	bd2out.count
#define	bd2out_addr	bd2out.addr
#define	bd2in_stat	bd2in.stat
#define	bd2in_count	bd2in.count
#define	bd2in_addr	bd2in.addr
#define	bd3out_stat	bd3out.stat
#define	bd3out_count	bd3out.count
#define	bd3out_addr	bd3out.addr
#define	bd3in_stat	bd3in.stat
#define	bd3in_count	bd3in.count
#define	bd3in_addr	bd3in.addr
#endif

extern uns8 buffer_0_out[USB_EP0_OUT_SIZE];
extern uns8 buffer_0_in [USB_EP0_IN_SIZE];

#ifdef USB_EP1_IN_SIZE
	extern uns8 buffer_1_in [USB_EP1_IN_SIZE];
#endif
#ifdef USB_EP1_OUT_SIZE
	extern uns8 buffer_1_out [USB_EP1_OUT_SIZE];
#endif
#ifdef USB_EP2_IN_SIZE
	extern uns8 buffer_2_in [USB_EP2_IN_SIZE];
#endif
#ifdef USB_EP2_OUT_SIZE
	extern uns8 buffer_2_out [USB_EP2_OUT_SIZE];
#endif
#ifdef USB_EP3_IN_SIZE
	extern uns8 buffer_3_in [USB_EP3_IN_SIZE];
#endif
#ifdef USB_EP3_OUT_SIZE
	extern uns8 buffer_3_out [USB_EP3_OUT_SIZE];
#endif

#if 0 //!defined(MX_USB_TYPE5) && !defined (MX_USB_TYPE6)
extern buffer_descriptor * ep_in_bd_location[USB_HIGHEST_EP + 1];
extern buffer_descriptor * ep_out_bd_location[USB_HIGHEST_EP + 1];
#endif

extern uns8 * ep_in_buffer_location[USB_HIGHEST_EP + 1];

extern uns8 * ep_out_buffer_location[USB_HIGHEST_EP + 1];

extern uns16 ep_in_buffer_size[USB_HIGHEST_EP + 1];

extern uns16 ep_out_buffer_size[USB_HIGHEST_EP + 1];

#endif
